#include <iostream>
#include "cv.h"
#include "highgui.h"
#include <string>
#include <vector>

using namespace std;
using namespace cv;

int main(int argc, char **argv) {
    const int width=200;
    const int height=200;
    
    // black/wihte picture example
    Mat bild(width,height,CV_8UC1);
    uchar *bptr=bild.data+(height>>2)*bild.step+(width>>2);
    for(int r=0;r<(height>>1);r++)
    {
      for(int c=0;c<(width>>1);c++) bptr[c]=255;
      bptr+=bild.step;
    }
    namedWindow("S/W (B/W)");
    imshow("S/W (B/W)",bild);
    // color example
    bild = Mat(width,height,CV_8UC3);
    // OpenCV uses BGR system
    uchar *rbptr=bild.data + (height>>3)*bild.step + (width>>3)*bild.elemSize() + 2;
    uchar *gbptr=bild.data + (height>>4)*bild.step + (width*3/8)*bild.elemSize() + 1;
    uchar *bbptr=bild.data + (height*3/8)*bild.step + (width>>2)*bild.elemSize();
    for(int r=0;r<(height>>1);r++)
    {
      uchar *rptr=rbptr;
      uchar *gptr=gbptr;
      uchar *bptr=bbptr;
      for(int c=0;c<(width>>1)*3;c+=3) 
      {
	rptr[c]=255;
	gptr[c]=255;
	bptr[c]=255;
      }
      rbptr+=bild.step;
      gbptr+=bild.step;
      bbptr+=bild.step;
    }
    namedWindow("Farbbild (Color image)");
    imshow("Farbbild (Color image)",bild);
    
    // another color example
    bild=Scalar(0,0,0);
    struct pixel_bgr_t{
      uchar b;
      uchar g;
      uchar r;
    } *pixelbptr;
    pixelbptr = (pixel_bgr_t *)(bild.data + (height>>2)*bild.step + (width>>2)*bild.elemSize());
    int wh=width>>1;
    int hh=height>>1;
    for(int r=0;r<hh;r++)
    {
      pixel_bgr_t *pixel=pixelbptr;
      for(int c=0;c<wh;c++)
      {
	pixel[c].r=(wh-c)*255/wh;
	pixel[c].g=c*255/wh;
	pixel[c].b=r*255/hh;
      }
      pixelbptr = (pixel_bgr_t *) (((uchar *) pixelbptr) + bild.step);
    }
   
    namedWindow("Farbbild (Color image) 2");
    imshow("Farbbild (Color image) 2",bild);
    
    waitKey(0);
    return 0;
}
